package ip;

import java.awt.*; 
import java.applet.Applet; 

/** This class is used to launch a new NetworkDialog which will result in a new
    NetworkFrame.  It can run as an Applet or from the command line. */
public class IPAddressManager extends Applet { 

/** Starts the Applet by creating a new dialog and new NetworkFrame. */
   public void start() {
      NetworkDialog nd=new NetworkDialog(new Frame());
      nd.setVisible(true);
      if(nd.getNetwork()!=null) new NetworkFrame(nd.getNetwork());
   }

/** The entry point for command line launching of this application.  Creates a Frame
    to hold the Applet panel. */
   public static void main(String[] args) {
      if(args.length==0) {
         NetworkDialog nd=new NetworkDialog(new Frame());
         nd.setVisible(true);
         if(nd.getNetwork()!=null) new NetworkFrame(nd.getNetwork());
      } else {
         String mask="255.255.255.0";
         String addr=new String("");
         String gw="1.1.1.1";
         if(args.length>0) {
            addr=args[0];
            gw=IPAddress.makeDefaultGateway(addr);
         }
         if(args.length>1) mask=args[1];
         if(args.length>2) gw=args[2];

         NetworkFrame nf=new NetworkFrame(new Subnet(addr,mask,gw));
      }
   }
} 
