package ip;

import java.io.*;
import java.util.StringTokenizer;

public class IPReader extends FileReader {
   private String filename=null;
   private BufferedReader bf;
   private Subnet network=null;

   public IPReader(String name) throws IOException {
      super(name);
      bf=new BufferedReader(this);
      filename=name;
      if(bf.readLine().trim().equals("Network")) {
         network=readSubnet();
      } else throw (new IOException());
   }

   public Subnet getNetwork() {return network;}

   public Subnet readNet() throws IOException {
      while(!(bf.readLine().trim().equals("Allocated Subnets"))) ;
         Subnet sn=null;
         do {
            sn=readSubnet();
            if(sn!=null) network.addSubnet(sn);
         } while(sn!=null);
         return network;
   }

   public Subnet readSubnet() throws IOException{
      String str=bf.readLine();
      if(str==null) return null;
      StringTokenizer netstring=new StringTokenizer(str,",");
      String addr=null,nmask=null,dgwy=null;
      addr=netstring.nextToken();
      nmask=netstring.nextToken();
      dgwy=netstring.nextToken();
      if(addr==null || nmask==null || dgwy==null) throw (new IOException());
      return new Subnet(addr,nmask,dgwy);
   }

   public static void main(String[] args) throws IOException{
      IPReader ipr=new IPReader("192.168.1.0.txt");
      Subnet sn=ipr.readNet();
      IPWriter w=new IPWriter("ww.txt");
      w.write(sn);
   }   
} 
