package ip;

import java.io.*; 

public class IPWriter extends FileWriter {
   private String filename=null;
   private boolean isTop;
   private BufferedWriter bf;

   public IPWriter(String name) throws IOException {
      super(name);
      bf=new BufferedWriter(this);
      filename=name;
      isTop=true;
   }

   public void write(Subnet net) throws IOException {
      boolean flag=false;
      if(isTop) {
         bf.write("Network");
         bf.newLine();
         writeLine(net);
         bf.newLine();
         bf.newLine();
         bf.write("Allocated Subnets");
         bf.newLine();
         isTop=false;
         flag=true;
      }
      if(net.hasSubnet()) {
         write(net.getChild0());
         write(net.getChild1());
      } else if(!net.isAvailable()) writeLine(net);
      if(flag) {
         bf.flush();
         bf.close();
         isTop=true;
      }
   }

   public void writeLine(Subnet net) throws IOException {
      String str=net.toString()+","+net.getCount();
      bf.write(str,0,str.length());
      bf.newLine();
   }
} 
