package ip;

import java.awt.*; 
import java.awt.event.*; 

public class NetworkDialog extends Dialog  implements ActionListener,WindowListener,KeyListener,FocusListener { 
   TextField addressField=new TextField(15);
   TextField netMaskField=new TextField("255.255.255.0",15);
   TextField defaultGatewayField=new TextField(15);
   Button submitButton=new Button("Submit");
   Button cancelButton=new Button("Cancel");
   Subnet sn=null;
   private boolean modified=false;

   
   public NetworkDialog(Frame owner) {
      super((Frame) owner);
      addWindowListener(this);
      setModal(true);
      setLayout(new GridLayout(4,2,2,2));

      addressField.addKeyListener(this);
      netMaskField.addKeyListener(this);
      defaultGatewayField.addKeyListener(this);
      addressField.addFocusListener(this);
      netMaskField.addFocusListener(this);
      defaultGatewayField.addFocusListener(this);

      submitButton.addActionListener(this);
      cancelButton.addActionListener(this);

      setTitle("Create A Network");

      add(new Label("Enter IP Address"));
      add(addressField);
      add(new Label("Enter Network Mask"));
      add(netMaskField);
      add(new Label("Enter Default Gateway"));
      add(defaultGatewayField);
      add(submitButton);
      add(cancelButton);
      pack();
   }

   public void actionPerformed(ActionEvent e) {
      try {
         if(e.getActionCommand().equals("Submit")) {
            sn=new Subnet(addressField.getText(),netMaskField.getText(),defaultGatewayField.getText());
         } else sn=null;
         hide();
      } catch (NumberFormatException nfe) {System.out.println("Bad input");}
   }

   public Subnet getNetwork() {return sn;}

   public void windowActivated(WindowEvent e) {;}

   public void windowClosed(WindowEvent e) {;}

   public void windowClosing(WindowEvent e) {
      setVisible(false);
      dispose();
   } 

   public void windowDeactivated(WindowEvent e) {;} 

   public void windowDeiconified(WindowEvent e) {;} 

   public void windowIconified(WindowEvent e) {;} 

   public void windowOpened(WindowEvent e) {;} 

   public void keyPressed(KeyEvent e) {;}

   public void keyTyped(KeyEvent e) {;}

   public void keyReleased(KeyEvent e) {
      if(e.getKeyCode()==KeyEvent.VK_ENTER) transferFocus();
      if(defaultGatewayField==(TextField) e.getSource()) {
         if(Character.isLetterOrDigit(e.getKeyChar())) modified=true;
         else if(defaultGatewayField.getText().length()==0) modified=false;
      }
   }

   public void focusGained(FocusEvent e) {
      ((TextField) e.getSource()).selectAll();
   }

   public void focusLost(FocusEvent e) {
      Object temp=e.getSource();
      if(temp==submitButton || temp==cancelButton) return;
      TextField tf=(TextField) temp; 
      tf.select(0,0);
      if(!modified) {
         if(tf!=defaultGatewayField) {
            try {
               defaultGatewayField.setText
                  (IPAddress.makeDefaultGateway(addressField.getText()));
            } catch(NumberFormatException nf) {;}
         } 
      }
   }

   public static void main(String[] args) {
      NetworkDialog nd=new NetworkDialog(new Frame());
      nd.setVisible(true);
      if(nd.getNetwork()!=null) new NetworkFrame(nd.getNetwork());
   } 
} 
