package ip;

import java.awt.*; 
import java.awt.event.*; 
import java.util.Vector;

public class SubnetPanel extends Panel implements ActionListener {
   private Label ipLabel=new Label();
   private Label netMaskLabel=new Label();
   private Label defaultGatewayLabel=new Label();
   private Button subnetButton=new Button("Subnet");
   private Button deleteButton=new Button("Delete");
   private Subnet subnet;
   private Vector holder=new Vector();

   public SubnetPanel(Subnet sn) {
      subnet=sn;
      ipLabel.setText(sn.getIPAddressString());
      netMaskLabel.setText(sn.getNetMaskString());
      defaultGatewayLabel.setText(sn.getDefaultGatewayString());
      setLayout(new GridLayout(5,2,4,1));
      add(new Label("IP Address:"));
      add(ipLabel);
      add(new Label("Subnet Mask:"));
      add(netMaskLabel);
      add(new Label("Default Gateway:"));
      add(defaultGatewayLabel);
      add(new Label("Addresses:  "));
      add(new Label(""+sn.getCount()));
      add(subnetButton);
      add(deleteButton);
      setBackground(Color.white);
      subnetButton.addActionListener(this);
      deleteButton.addActionListener(this);
   }

   public void actionPerformed(ActionEvent e) {
     if(e.getActionCommand().equals("Subnet")) {
        if(subnet.getCount()>4) {
           Subnet sn=new Subnet(subnet.getIPAddress(),subnet.getNetMask(),subnet.getDefaultGateway());
           new NetworkFrame(sn);
        }
     } else if(e.getActionCommand().equals("Delete")) {
        Panel p=(Panel) getParent();
        p.remove(this);
        p.validate();
        ((NetworkFrame)(p.getParent().getParent())).getNetwork().deleteSubnet(subnet);
     }
  }

        

   public static void main(String[] args) {
      Frame f=new Frame();
      f.add(new SubnetPanel(new Subnet(0,0,0)));
      f.pack();
      f.setVisible(true);
   }
} 
